diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/table.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/table.js
index 78ab8f3b..2eb7f59f 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/table.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/table.js
@@ -1,13 +1,15 @@
 define('pgadmin.node.table', [
   'sources/gettext', 'sources/url_for', 'jquery', 'underscore',
-  'underscore.string', 'sources/pgadmin', 'pgadmin.browser', 'pgadmin.alertifyjs',
+  'underscore.string', 'sources/pgadmin', 'pgadmin.browser',
+  'pgadmin.alertifyjs', 'pgadmin.backform', 'pgadmin.backgrid',
   'pgadmin.browser.collection', 'pgadmin.node.column',
-  'pgadmin.node.constraints', 'pgadmin.browser.table.partition.utils'
+  'pgadmin.node.constraints', 'pgadmin.browser.table.partition.utils',
 ], function(
-  gettext, url_for, $, _, S, pgAdmin, pgBrowser, alertify) {
+  gettext, url_for, $, _, S, pgAdmin, pgBrowser, Alertify, Backform, Backgrid
+) {
 
   if (!pgBrowser.Nodes['coll-table']) {
-    var databases = pgBrowser.Nodes['coll-table'] =
+    pgBrowser.Nodes['coll-table'] =
       pgBrowser.Collection.extend({
         node: 'table',
         label: gettext('Tables'),
@@ -15,10 +17,10 @@ define('pgadmin.node.table', [
         columns: ['name', 'relowner', 'is_partitioned', 'description'],
         hasStatistics: true,
         statsPrettifyFields: ['Size', 'Indexes size', 'Table size',
-                              'Toast table size', 'Tuple length',
-                              'Dead tuple length', 'Free space']
+          'Toast table size', 'Tuple length',
+          'Dead tuple length', 'Free space'],
       });
-  };
+  }
 
   if (!pgBrowser.Nodes['table']) {
     pgBrowser.Nodes['table'] = pgBrowser.Node.extend({
@@ -30,8 +32,8 @@ define('pgadmin.node.table', [
       hasDepends: true,
       hasStatistics: true,
       statsPrettifyFields: ['Size', 'Indexes size', 'Table size',
-                            'Toast table size', 'Tuple length',
-                            'Dead tuple length', 'Free space'],
+        'Toast table size', 'Tuple length',
+        'Dead tuple length', 'Free space'],
       sqlAlterHelp: 'sql-altertable.html',
       sqlCreateHelp: 'sql-createtable.html',
       dialogHelp: url_for('help.static', {'filename': 'table_dialog.html'}),
@@ -42,7 +44,7 @@ define('pgadmin.node.table', [
       Init: function() {
         /* Avoid multiple registration of menus */
         if (this.initialized)
-            return;
+          return;
 
         this.initialized = true;
 
@@ -51,51 +53,51 @@ define('pgadmin.node.table', [
           applies: ['object', 'context'], callback: 'show_obj_properties',
           category: 'create', priority: 1, label: gettext('Table...'),
           icon: 'wcTabIcon icon-table', data: {action: 'create', check: true},
-          enable: 'canCreate'
+          enable: 'canCreate',
         },{
           name: 'create_table', node: 'table', module: this,
           applies: ['object', 'context'], callback: 'show_obj_properties',
           category: 'create', priority: 1, label: gettext('Table...'),
           icon: 'wcTabIcon icon-table', data: {action: 'create', check: true},
-          enable: 'canCreate'
+          enable: 'canCreate',
         },{
           name: 'create_table__on_schema', node: 'schema', module: this,
           applies: ['object', 'context'], callback: 'show_obj_properties',
           category: 'create', priority: 4, label: gettext('Table...'),
           icon: 'wcTabIcon icon-table', data: {action: 'create', check: false},
-          enable: 'canCreate'
+          enable: 'canCreate',
         },{
           name: 'truncate_table', node: 'table', module: this,
           applies: ['object', 'context'], callback: 'truncate_table',
           category: 'Truncate', priority: 3, label: gettext('Truncate'),
-          icon: 'fa fa-eraser', enable : 'canCreate'
+          icon: 'fa fa-eraser', enable : 'canCreate',
         },{
           name: 'truncate_table_cascade', node: 'table', module: this,
           applies: ['object', 'context'], callback: 'truncate_table_cascade',
           category: 'Truncate', priority: 3, label: gettext('Truncate Cascade'),
-          icon: 'fa fa-eraser', enable : 'canCreate'
+          icon: 'fa fa-eraser', enable : 'canCreate',
         },{
           // To enable/disable all triggers for the table
           name: 'enable_all_triggers', node: 'table', module: this,
           applies: ['object', 'context'], callback: 'enable_triggers_on_table',
           category: 'Trigger(s)', priority: 4, label: gettext('Enable All'),
-          icon: 'fa fa-check', enable : 'canCreate_with_trigger_enable'
+          icon: 'fa fa-check', enable : 'canCreate_with_trigger_enable',
         },{
           name: 'disable_all_triggers', node: 'table', module: this,
           applies: ['object', 'context'], callback: 'disable_triggers_on_table',
           category: 'Trigger(s)', priority: 4, label: gettext('Disable All'),
-          icon: 'fa fa-times', enable : 'canCreate_with_trigger_disable'
+          icon: 'fa fa-times', enable : 'canCreate_with_trigger_disable',
         },{
           name: 'reset_table_stats', node: 'table', module: this,
           applies: ['object', 'context'], callback: 'reset_table_stats',
           category: 'Reset', priority: 4, label: gettext('Reset Statistics'),
-          icon: 'fa fa-bar-chart', enable : 'canCreate'
+          icon: 'fa fa-bar-chart', enable : 'canCreate',
         },{
           name: 'count_table_rows', node: 'table', module: this,
           applies: ['object', 'context'], callback: 'count_table_rows',
           category: 'Count', priority: 2, label: gettext('Count Rows'),
-          enable: true
-        }
+          enable: true,
+        },
         ]);
         pgBrowser.Events.on(
           'pgadmin:browser:node:table:updated', this.onTableUpdated, this
@@ -114,22 +116,22 @@ define('pgadmin.node.table', [
       callbacks: {
         /* Enable trigger(s) on table */
         enable_triggers_on_table: function(args) {
-            var params = {'enable': true };
-            this.callbacks.set_triggers.apply(this, [args, params]);
+          var params = {'enable': true };
+          this.callbacks.set_triggers.apply(this, [args, params]);
         },
         /* Disable trigger(s) on table */
         disable_triggers_on_table: function(args) {
-            var params = {'enable': false };
-            this.callbacks.set_triggers.apply(this, [args, params]);
+          var params = {'enable': false };
+          this.callbacks.set_triggers.apply(this, [args, params]);
         },
         set_triggers: function(args, params) {
           // This function will send request to enable or
           // disable triggers on table level
           var input = args || {},
-          obj = this,
-          t = pgBrowser.tree,
-          i = input.item || t.selected(),
-          d = i && i.length == 1 ? t.itemData(i) : undefined;
+            obj = this,
+            t = pgBrowser.tree,
+            i = input.item || t.selected(),
+            d = i && i.length == 1 ? t.itemData(i) : undefined;
           if (!d)
             return false;
 
@@ -137,10 +139,10 @@ define('pgadmin.node.table', [
             url: obj.generate_url(i, 'set_trigger' , d, true),
             type:'PUT',
             data: params,
-            dataType: "json",
+            dataType: 'json',
             success: function(res) {
               if (res.success == 1) {
-                alertify.success(res.info);
+                Alertify.success(res.info);
                 t.unload(i);
                 t.setInode(i);
                 t.deselect(i);
@@ -149,76 +151,80 @@ define('pgadmin.node.table', [
                 }, 10);
               }
             },
-            error: function(xhr, status, error) {
+            error: function(xhr) {
               try {
                 var err = $.parseJSON(xhr.responseText);
                 if (err.success == 0) {
-                  alertify.error(err.errormsg);
+                  Alertify.error(err.errormsg);
                 }
-              } catch (e) {}
+              } catch (e) {
+                console.warn(e.stack || e);
+              }
               t.unload(i);
-            }
+            },
           });
         },
         /* Truncate table */
         truncate_table: function(args) {
-            var params = {'cascade': false };
-            this.callbacks.truncate.apply(this, [args, params]);
+          var params = {'cascade': false };
+          this.callbacks.truncate.apply(this, [args, params]);
         },
         /* Truncate table with cascade */
         truncate_table_cascade: function(args) {
-            var params = {'cascade': true };
-            this.callbacks.truncate.apply(this, [args, params]);
+          var params = {'cascade': true };
+          this.callbacks.truncate.apply(this, [args, params]);
         },
         truncate: function(args, params) {
           var input = args || {},
-          obj = this,
-          t = pgBrowser.tree,
-          i = input.item || t.selected(),
-          d = i && i.length == 1 ? t.itemData(i) : undefined;
+            obj = this,
+            t = pgBrowser.tree,
+            i = input.item || t.selected(),
+            d = i && i.length == 1 ? t.itemData(i) : undefined;
 
           if (!d)
             return false;
 
-          alertify.confirm(
+          Alertify.confirm(
             gettext('Truncate Table'),
             S(gettext('Are you sure you want to truncate table %s?')).sprintf(d.label).value(),
             function (e) {
-            if (e) {
-              var data = d;
-              $.ajax({
-                url: obj.generate_url(i, 'truncate' , d, true),
-                type:'PUT',
-                data: params,
-                dataType: "json",
-                success: function(res) {
-                  if (res.success == 1) {
-                    alertify.success(res.info);
-                    t.removeIcon(i);
-                    data.icon = data.is_partitioned ? 'icon-partition': 'icon-table';
-                    t.addIcon(i, {icon: data.icon});
-                    t.unload(i);
-                    t.setInode(i);
-                    t.deselect(i);
-                    // Fetch updated data from server
-                    setTimeout(function() {
-                      t.select(i);
-                    }, 10);
-                  }
-                },
-                error: function(xhr, status, error) {
-                  try {
-                    var err = $.parseJSON(xhr.responseText);
-                    if (err.success == 0) {
-                      alertify.error(err.errormsg);
+              if (e) {
+                var data = d;
+                $.ajax({
+                  url: obj.generate_url(i, 'truncate' , d, true),
+                  type:'PUT',
+                  data: params,
+                  dataType: 'json',
+                  success: function(res) {
+                    if (res.success == 1) {
+                      Alertify.success(res.info);
+                      t.removeIcon(i);
+                      data.icon = data.is_partitioned ? 'icon-partition': 'icon-table';
+                      t.addIcon(i, {icon: data.icon});
+                      t.unload(i);
+                      t.setInode(i);
+                      t.deselect(i);
+                      // Fetch updated data from server
+                      setTimeout(function() {
+                        t.select(i);
+                      }, 10);
                     }
-                  } catch (e) {}
-                  t.unload(i);
-                }
-              });
-            }
-          }, function() {}
-        );
+                  },
+                  error: function(xhr) {
+                    try {
+                      var err = $.parseJSON(xhr.responseText);
+                      if (err.success == 0) {
+                        Alertify.error(err.errormsg);
+                      }
+                    } catch (e) {
+                      console.warn(e.stack || e);
+                    }
+                    t.unload(i);
+                  },
+                });
+              }
+            }, function() {}
+          );
         },
         reset_table_stats: function(args) {
           var input = args || {},
@@ -230,7 +236,7 @@ define('pgadmin.node.table', [
           if (!d)
             return false;
 
-          alertify.confirm(
+          Alertify.confirm(
             gettext('Reset statistics'),
             S(gettext('Are you sure you want to reset the statistics for table "%s"?')).sprintf(d._label).value(),
             function (e) {
@@ -241,7 +247,7 @@ define('pgadmin.node.table', [
                   type:'DELETE',
                   success: function(res) {
                     if (res.success == 1) {
-                      alertify.success(res.info);
+                      Alertify.success(res.info);
                       t.removeIcon(i);
                       data.icon = data.is_partitioned ? 'icon-partition': 'icon-table';
                       t.addIcon(i, {icon: data.icon});
@@ -254,15 +260,17 @@ define('pgadmin.node.table', [
                       }, 10);
                     }
                   },
-                  error: function(xhr, status, error) {
+                  error: function(xhr) {
                     try {
                       var err = $.parseJSON(xhr.responseText);
                       if (err.success == 0) {
-                        alertify.error(err.errormsg);
+                        Alertify.error(err.errormsg);
                       }
-                    } catch (e) {}
+                    } catch (e) {
+                      console.warn(e.stack || e);
+                    }
                     t.unload(i);
-                  }
+                  },
                 });
               }
             },
@@ -271,10 +279,10 @@ define('pgadmin.node.table', [
         },
         count_table_rows: function(args) {
           var input = args || {},
-          obj = this,
-          t = pgBrowser.tree,
-          i = input.item || t.selected(),
-          d = i && i.length == 1 ? t.itemData(i) : undefined;
+            obj = this,
+            t = pgBrowser.tree,
+            i = input.item || t.selected(),
+            d = i && i.length == 1 ? t.itemData(i) : undefined;
           if (!d)
             return false;
 
@@ -283,26 +291,28 @@ define('pgadmin.node.table', [
             url: obj.generate_url(i, 'count_rows' , d, true),
             type:'GET',
             success: function(res) {
-                alertify.success(res.info);
-                d.rows_cnt = res.data.total_rows;
-                t.unload(i);
-                t.setInode(i);
-                t.deselect(i);
-                setTimeout(function() {
-                  t.select(i);
-                }, 10);
+              Alertify.success(res.info);
+              d.rows_cnt = res.data.total_rows;
+              t.unload(i);
+              t.setInode(i);
+              t.deselect(i);
+              setTimeout(function() {
+                t.select(i);
+              }, 10);
             },
-            error: function(xhr, status, error) {
+            error: function(xhr) {
               try {
                 var err = $.parseJSON(xhr.responseText);
                 if (err.success == 0) {
-                  alertify.error(err.errormsg);
+                  Alertify.error(err.errormsg);
                 }
-              } catch (e) {}
+              } catch (e) {
+                console.warn(e.stack || e);
+              }
               t.unload(i);
-            }
+            },
           });
-        }
+        },
       },
       model: pgBrowser.Node.Model.extend({
         defaults: {
@@ -334,18 +344,18 @@ define('pgadmin.node.table', [
           primary_key: [],
           partitions: [],
           partition_type: 'range',
-          is_partitioned: false
+          is_partitioned: false,
         },
         // Default values!
         initialize: function(attrs, args) {
-          var self = this;
-
           if (_.size(attrs) === 0) {
-            var userInfo = pgBrowser.serverInfo[args.node_info.server._id].user,
-                schemaInfo = args.node_info.schema;
+            var userInfo = pgBrowser.serverInfo[
+              args.node_info.server._id
+            ].user,
+              schemaInfo = args.node_info.schema;
 
             this.set({
-              'relowner': userInfo.name, 'schema': schemaInfo._label
+              'relowner': userInfo.name, 'schema': schemaInfo._label,
             }, {silent: true});
           }
           pgBrowser.Node.Model.prototype.initialize.apply(this, arguments);
@@ -353,13 +363,13 @@ define('pgadmin.node.table', [
         },
         schema: [{
           id: 'name', label: gettext('Name'), type: 'text',
-          mode: ['properties', 'create', 'edit'], disabled: 'inSchema'
+          mode: ['properties', 'create', 'edit'], disabled: 'inSchema',
         },{
-          id: 'oid', label: gettext('OID'), type: 'text', mode: ['properties']
+          id: 'oid', label: gettext('OID'), type: 'text', mode: ['properties'],
         },{
           id: 'relowner', label: gettext('Owner'), type: 'text', node: 'role',
           mode: ['properties', 'create', 'edit'], select2: {allowClear: false},
-          disabled: 'inSchema', control: 'node-list-by-name'
+          disabled: 'inSchema', control: 'node-list-by-name',
         },{
           id: 'schema', label: gettext('Schema'), type: 'text', node: 'schema',
           control: 'node-list-by-name', mode: ['create', 'edit'],
@@ -370,15 +380,15 @@ define('pgadmin.node.table', [
               return false;
             }
             return true;
-          }, cache_node: 'database', cache_level: 'database'
+          }, cache_node: 'database', cache_level: 'database',
         },{
           id: 'spcname', label: gettext('Tablespace'), node: 'tablespace',
           type: 'text', control: 'node-list-by-name', disabled: 'inSchema',
           mode: ['properties', 'create', 'edit'],
           filter: function(d) {
             // If tablespace name is not "pg_global" then we need to exclude them
-            return (!(d && d.label.match(/pg_global/)))
-          }
+            return (!(d && d.label.match(/pg_global/)));
+          },
         },{
           id: 'partition', type: 'group', label: gettext('Partition'),
           mode: ['edit', 'create'], min_version: 100000,
@@ -387,14 +397,14 @@ define('pgadmin.node.table', [
             if (m.isNew() || m.get('is_partitioned'))
               return true;
             return false;
-          }
+          },
         },{
           id: 'is_partitioned', label:gettext('Partitioned Table?'), cell: 'switch',
           type: 'switch', mode: ['properties', 'create', 'edit'],
           visible: function(m) {
             if(!_.isUndefined(m.node_info) && !_.isUndefined(m.node_info.server)
               && !_.isUndefined(m.node_info.server.version) &&
-              m.node_info.server.version >= 100000)
+                m.node_info.server.version >= 100000)
               return true;
 
             return false;
@@ -403,31 +413,31 @@ define('pgadmin.node.table', [
             if (!m.isNew())
               return true;
             return false;
-          }
+          },
         },{
           id: 'description', label: gettext('Comment'), type: 'multiline',
-          mode: ['properties', 'create', 'edit'], disabled: 'inSchema'
+          mode: ['properties', 'create', 'edit'], disabled: 'inSchema',
         },{
           id: 'coll_inherits', label: gettext('Inherited from table(s)'),
           url: 'get_inherits', type: 'array', group: gettext('Columns'),
           disabled: 'checkInheritance', deps: ['typname', 'is_partitioned'],
           mode: ['create', 'edit'],
           select2: { multiple: true, allowClear: true,
-          placeholder: gettext('Select to inherit from...')},
+            placeholder: gettext('Select to inherit from...')},
           transform: function(data, cell) {
             var control = cell || this,
               m = control.model;
-              m.inherited_tables_list = data;
-              return data;
+            m.inherited_tables_list = data;
+            return data;
           },
           control: Backform.MultiSelectAjaxControl.extend({
             // When changes we need to add/clear columns collection
             onChange: function() {
               Backform.MultiSelectAjaxControl.prototype.onChange.apply(this, arguments);
               var self = this,
-              // current table list and previous table list
-              cTbl_list = self.model.get('coll_inherits') || [],
-              pTbl_list = self.model.previous('coll_inherits') || [];
+                // current table list and previous table list
+                cTbl_list = self.model.get('coll_inherits') || [],
+                pTbl_list = self.model.previous('coll_inherits') || [];
 
               if (!_.isUndefined(cTbl_list)) {
                 var tbl_name = undefined,
@@ -463,13 +473,11 @@ define('pgadmin.node.table', [
               // Create copy of old model if anything goes wrong at-least we have backup
               // Then send AJAX request to fetch table specific columns
               var self = this,
-                url = 'get_columns',
                 m = self.model.top || self.model,
                 data = undefined,
-                old_columns = _.clone(m.get('columns')),
                 column_collection = m.get('columns');
 
-              var arg = {'tid': tid}
+              var arg = {'tid': tid};
               data = self.model.fetch_columns_ajax.apply(self, [arg]);
 
               // Update existing column collection
@@ -486,20 +494,20 @@ define('pgadmin.node.table', [
               var tbl_oid = undefined;
               // iterate over list to find table oid
               _.each(this.model.inherited_tables_list, function(obj) {
-                  if(obj.label === tblname) {
-                    tbl_oid = obj.tid;
-                  }
+                if(obj.label === tblname) {
+                  tbl_oid = obj.tid;
+                }
               });
               return tbl_oid;
-            }
-          })
+            },
+          }),
         },{
           id: 'coll_inherits', label: gettext('Inherited from table(s)'),
-          type: 'text', group: gettext('Advanced'), mode: ['properties']
+          type: 'text', group: gettext('Advanced'), mode: ['properties'],
         },{
           id: 'inherited_tables_cnt', label: gettext('Inherited tables count'),
           type: 'text', mode: ['properties'], group: gettext('Advanced'),
-          disabled: 'inSchema'
+          disabled: 'inSchema',
         },{
           // Tab control for columns
           id: 'columns', label: gettext('Columns'), type: 'collection',
@@ -538,20 +546,20 @@ define('pgadmin.node.table', [
             initialize: function() {
               Backform.UniqueColCollectionControl.prototype.initialize.apply(this, arguments);
               var self = this,
-                  collection = self.model.get(self.field.get('name'));
+                collection = self.model.get(self.field.get('name'));
 
-              collection.on("change:is_primary_key", function(m) {
+              collection.on('change:is_primary_key', function(m) {
                 var primary_key_coll = self.model.get('primary_key'),
-                    column_name = m.get('name'),
-                    primary_key;
+                  column_name = m.get('name'),
+                  primary_key, primary_key_column_coll;
 
                 if(m.get('is_primary_key')) {
-                // Add column to primary key.
+                  // Add column to primary key.
                   if (primary_key_coll.length < 1) {
                     primary_key = new (primary_key_coll.model)({}, {
                       top: self.model,
                       collection: primary_key_coll,
-                      handler: primary_key_coll
+                      handler: primary_key_coll,
                     });
                     primary_key_coll.add(primary_key);
                   } else {
